'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _createStylingFromTheme = require('./createStylingFromTheme');

var _function = require('react-pure-render/function');

var _function2 = _interopRequireDefault(_function);

var _ActionList = require('./ActionList');

var _ActionList2 = _interopRequireDefault(_ActionList);

var _ActionPreview = require('./ActionPreview');

var _ActionPreview2 = _interopRequireDefault(_ActionPreview);

var _getInspectedState = require('./getInspectedState');

var _getInspectedState2 = _interopRequireDefault(_getInspectedState);

var _DiffPatcher = require('./DiffPatcher');

var _DiffPatcher2 = _interopRequireDefault(_DiffPatcher);

var _reactBase16Styling = require('react-base16-styling');

var _reduxDevtoolsThemes = require('redux-devtools-themes');

var base16Themes = _interopRequireWildcard(_reduxDevtoolsThemes);

var _themes = require('./themes');

var inspectorThemes = _interopRequireWildcard(_themes);

var _redux = require('./redux');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function getCurrentActionId(props) {
  var state = props.monitorState;
  var lastActionId = props.stagedActionIds[props.stagedActionIds.length - 1];
  return state.selectedActionId === null ? lastActionId : state.selectedActionId;
}

function createState(props) {
  var supportImmutable = props.supportImmutable;
  var computedStates = props.computedStates;
  var stagedActionIds = props.stagedActionIds;
  var actions = props.actionsById;
  var state = props.monitorState;

  var currentActionId = getCurrentActionId(props, state);
  var currentAction = actions[currentActionId] && actions[currentActionId].action;

  var actionIndex = stagedActionIds.indexOf(currentActionId);
  var fromState = actionIndex > 0 ? computedStates[actionIndex - 1] : null;
  var toState = computedStates[actionIndex];

  var fromInspectedState = fromState && (0, _getInspectedState2.default)(fromState.state, state.inspectedStatePath, supportImmutable);
  var toInspectedState = toState && (0, _getInspectedState2.default)(toState.state, state.inspectedStatePath, supportImmutable);
  var delta = fromState && toState && _DiffPatcher2.default.diff(fromInspectedState, toInspectedState);

  return {
    delta: delta,
    currentActionId: currentActionId,
    nextState: toState && (0, _getInspectedState2.default)(toState.state, state.inspectedStatePath, false),
    action: (0, _getInspectedState2.default)(currentAction, state.inspectedActionPath, false)
  };
}

function createThemeState(props) {
  var themes = (0, _extends3.default)({}, base16Themes, inspectorThemes);
  var base16Theme = (0, _reactBase16Styling.getBase16Theme)(props.theme, themes);
  var styling = (0, _createStylingFromTheme.createStylingFromTheme)(props.theme, themes, props.isLightTheme);

  return { base16Theme: base16Theme, styling: styling };
}

var DevtoolsInspector = function (_Component) {
  (0, _inherits3.default)(DevtoolsInspector, _Component);

  function DevtoolsInspector() {
    var _Object$getPrototypeO;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, DevtoolsInspector);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_Object$getPrototypeO = (0, _getPrototypeOf2.default)(DevtoolsInspector)).call.apply(_Object$getPrototypeO, [this].concat(args))), _this), _this.state = {
      isWideLayout: false,
      selectedActionId: null,
      inspectedActionPath: [],
      inspectedStatePath: [],
      tab: 'Diff',
      isLightTheme: true
    }, _this.shouldComponentUpdate = _function2.default, _this.handleSearch = function (val) {
      _this.props.dispatch((0, _redux.updateMonitorState)({ searchValue: val }));
    }, _this.handleSelectAction = function (actionId) {
      var selectedActionId = _this.props.monitorState.selectedActionId;


      _this.props.dispatch((0, _redux.updateMonitorState)({
        selectedActionId: actionId === selectedActionId ? null : actionId
      }));
    }, _this.handleInspectPath = function (pathType, path) {
      _this.props.dispatch((0, _redux.updateMonitorState)((0, _defineProperty3.default)({}, pathType, path)));
    }, _this.handleSelectTab = function (tab) {
      _this.props.dispatch((0, _redux.updateMonitorState)({ tab: tab }));
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(DevtoolsInspector, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      this.props.dispatch((0, _redux.updateMonitorState)((0, _extends3.default)({}, createState(this.props), createThemeState(this.props))));
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.updateSizeMode();
      this.updateSizeTimeout = window.setInterval(this.updateSizeMode.bind(this), 150);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      window.clearTimeout(this.updateSizeTimeout);
    }
  }, {
    key: 'updateSizeMode',
    value: function updateSizeMode() {
      var isWideLayout = this.refs.inspector.offsetWidth > 500;
      if (isWideLayout !== this.props.monitorState.isWideLayout) {
        this.props.dispatch((0, _redux.updateMonitorState)({ isWideLayout: isWideLayout }));
      }
    }
  }, {
    key: 'componentWillUpdate',
    value: function componentWillUpdate(nextProps) {
      var state = nextProps.monitorState;

      if (this.props.computedStates !== nextProps.computedStates || getCurrentActionId(this.props) !== getCurrentActionId(nextProps) || this.props.monitorState.inspectedStatePath !== nextProps.monitorState.inspectedStatePath || this.props.monitorState.inspectedActionPath !== nextProps.monitorState.inspectedActionPath) {

        state = (0, _extends3.default)({}, state, createState(nextProps));
      }

      if (this.props.theme !== nextProps.theme || this.props.isLightTheme !== nextProps.isLightTheme) {

        state = (0, _extends3.default)({}, state, createThemeState(nextProps));
      }

      if (state !== nextProps.monitorState) {
        nextProps.dispatch((0, _redux.updateMonitorState)(state));
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props;
      var actionIds = _props.stagedActionIds;
      var actions = _props.actionsById;
      var monitorState = _props.monitorState;
      var isLightTheme = _props.isLightTheme;
      var isWideLayout = monitorState.isWideLayout;
      var selectedActionId = monitorState.selectedActionId;
      var nextState = monitorState.nextState;
      var action = monitorState.action;
      var searchValue = monitorState.searchValue;
      var tab = monitorState.tab;
      var delta = monitorState.delta;
      var base16Theme = monitorState.base16Theme;
      var styling = monitorState.styling;

      var inspectedPathType = tab === 'Action' ? 'inspectedActionPath' : 'inspectedStatePath';

      return _react2.default.createElement(
        'div',
        (0, _extends3.default)({ key: 'inspector',
          ref: 'inspector'
        }, styling(['inspector', isWideLayout && 'inspectorWide'], isWideLayout)),
        _react2.default.createElement(_ActionList2.default, (0, _extends3.default)({ actions: actions, actionIds: actionIds, isWideLayout: isWideLayout, searchValue: searchValue, selectedActionId: selectedActionId }, {
          styling: styling,
          onSearch: this.handleSearch,
          onSelect: this.handleSelectAction })),
        _react2.default.createElement(_ActionPreview2.default, (0, _extends3.default)({ base16Theme: base16Theme, tab: tab, delta: delta, nextState: nextState, action: action, isLightTheme: isLightTheme }, {
          styling: styling,
          onInspectPath: this.handleInspectPath.bind(this, inspectedPathType),
          inspectedPath: monitorState[inspectedPathType],
          onSelectTab: this.handleSelectTab }))
      );
    }
  }]);
  return DevtoolsInspector;
}(_react.Component);

DevtoolsInspector.propTypes = {
  dispatch: _react.PropTypes.func,
  computedStates: _react.PropTypes.array,
  stagedActionIds: _react.PropTypes.array,
  actionsById: _react.PropTypes.object,
  currentStateIndex: _react.PropTypes.number,
  monitorState: _react.PropTypes.shape({
    initialScrollTop: _react.PropTypes.number
  }),
  preserveScrollTop: _react.PropTypes.bool,
  stagedActions: _react.PropTypes.array,
  select: _react.PropTypes.func.isRequired,
  theme: _react.PropTypes.oneOfType([_react.PropTypes.object, _react.PropTypes.string]),
  supportImmutable: _react.PropTypes.bool
};
DevtoolsInspector.update = _redux.reducer;
DevtoolsInspector.defaultProps = {
  select: function select(state) {
    return state;
  },
  supportImmutable: false,
  theme: 'inspector'
};
exports.default = DevtoolsInspector;