'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactJsonTree = require('react-json-tree');

var _reactJsonTree2 = _interopRequireDefault(_reactJsonTree);

var _javascriptStringify = require('javascript-stringify');

var _javascriptStringify2 = _interopRequireDefault(_javascriptStringify);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function stringifyAndShrink(val) {
  var str = (0, _javascriptStringify2.default)(val);
  if (val === null) {
    return 'null';
  } else if (typeof val === 'undefined') {
    return 'undefined';
  }

  return str.length > 22 ? str.substr(0, 15) + '…' + str.substr(-5) : str;
}

function prepareDelta(value) {
  if (value && value._t === 'a') {
    var res = {};
    for (var key in value) {
      if (key !== '_t') {
        if (key[0] === '_' && !value[key.substr(1)]) {
          res[key.substr(1)] = value[key];
        } else if (value['_' + key]) {
          res[key] = [value['_' + key][0], value[key][0]];
        } else if (!value['_' + key] && key[0] !== '_') {
          res[key] = value[key];
        }
      }
    }
    return res;
  }

  return value;
}

var JSONDiff = function (_Component) {
  (0, _inherits3.default)(JSONDiff, _Component);

  function JSONDiff() {
    (0, _classCallCheck3.default)(this, JSONDiff);
    return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(JSONDiff).apply(this, arguments));
  }

  (0, _createClass3.default)(JSONDiff, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props;
      var delta = _props.delta;
      var styling = _props.styling;
      var base16Theme = _props.base16Theme;
      var props = (0, _objectWithoutProperties3.default)(_props, ['delta', 'styling', 'base16Theme']);


      return _react2.default.createElement(_reactJsonTree2.default, (0, _extends3.default)({}, props, {
        theme: base16Theme,
        data: delta,
        getItemString: function getItemString() {
          return '';
        },
        valueRenderer: function valueRenderer(raw, value) {
          return _this2.valueRenderer(raw, value, styling);
        },
        postprocessValue: prepareDelta,
        isCustomNode: function isCustomNode(value) {
          return Array.isArray(value);
        },
        shouldExpandNode: function shouldExpandNode(keyName, data, level) {
          return level <= 1;
        },
        hideRoot: true }));
    }
  }, {
    key: 'valueRenderer',
    value: function valueRenderer(raw, value, styling) {
      function renderSpan(name, body) {
        return _react2.default.createElement(
          'span',
          (0, _extends3.default)({ key: name }, styling(['diff', name])),
          body
        );
      }

      if (Array.isArray(value)) {
        switch (value.length) {
          case 1:
            return _react2.default.createElement(
              'span',
              styling('diffWrap'),
              renderSpan('diffAdd', stringifyAndShrink(value[0]))
            );
          case 2:
            return _react2.default.createElement(
              'span',
              styling('diffWrap'),
              renderSpan('diffUpdateFrom', stringifyAndShrink(value[0])),
              renderSpan('diffUpdateArrow', ' => '),
              renderSpan('diffUpdateTo', stringifyAndShrink(value[1]))
            );
          case 3:
            return _react2.default.createElement(
              'span',
              styling('diffWrap'),
              renderSpan('diffRemove', stringifyAndShrink(value[0]))
            );
        }
      }

      return raw;
    }
  }]);
  return JSONDiff;
}(_react.Component);

exports.default = JSONDiff;